For AI agents: A markdown version of this page is available at https://docs.datadoghq.com/api/latest/security-monitoring/get-ast-for-source-code.md. A documentation index is available at /llms.txt.

Get AST for source code

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

POST https://api.ap1.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-asthttps://api.ap2.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-asthttps://api.datadoghq.eu/api/v2/static-analysis/static-analysis-server/get-asthttps://api.ddog-gov.com/api/v2/static-analysis/static-analysis-server/get-asthttps://api.us2.ddog-gov.com/api/v2/static-analysis/static-analysis-server/get-asthttps://api.uk1.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-asthttps://api.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-asthttps://api.us3.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-asthttps://api.us5.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-ast

Overview

Parse source code into an abstract syntax tree (AST) for the specified language.

OAuth apps require the code_analysis_read authorization scope to access this endpoint.

Request

Body Data (required)

Expand All

Field

Type

Description

_authentication_token

string

CSRF token for security, sent by browser-based clients. Ignored by the API when absent.

data [required]

object

The primary data object in the get-AST request.

attributes [required]

object

The attributes of the get-AST request, containing the source code to parse.

code [required]

string

The base64-encoded source code to parse into an abstract syntax tree.

file_encoding [required]

string

The encoding of the source code file (must be utf-8).

language [required]

string

The programming language of the source code to parse.

id

string

An optional identifier for the get-AST request resource.

type [required]

enum

Get AST request resource type. Allowed enum values: get_ast_request

default: get_ast_request

{
  "_authentication_token": "string",
  "data": {
    "attributes": {
      "code": "aW1wb3J0IHN5cw==",
      "file_encoding": "utf-8",
      "language": "python"
    },
    "id": "string",
    "type": "get_ast_request"
  }
}

Response

OK

The response payload containing the parsed abstract syntax tree.

Expand All

Field

Type

Description

data [required]

object

The primary data object in the get-AST response.

attributes [required]

object

The attributes of the get-AST response, containing the parsed abstract syntax tree.

result [required]

object

The root node of the parsed abstract syntax tree, or null when the source code could not be parsed.

ast_type [required]

string

The tree-sitter node type of this AST node.

children [required]

[object]

The child nodes of this AST node, or null for a leaf node.

[Circular]

end [required]

object

A position in source code, identified by line and column numbers.

col [required]

int64

The column number in the source file (1-based).

line [required]

int64

The line number in the source file (1-based).

field_name

string

The name of the field this node occupies within its parent node, when the parent addresses it by name.

start [required]

object

A position in source code, identified by line and column numbers.

col [required]

int64

The column number in the source file (1-based).

line [required]

int64

The line number in the source file (1-based).

id [required]

string

The identifier of the get-AST response resource, echoed from the request.

type [required]

enum

Get AST response resource type. Allowed enum values: get_ast_response

default: get_ast_response

{
  "data": {
    "attributes": {
      "result": {
        "ast_type": "module",
        "children": [
          {}
        ],
        "end": {
          "col": 5,
          "line": 10
        },
        "field_name": "string",
        "start": {
          "col": 5,
          "line": 10
        }
      }
    },
    "id": "",
    "type": "get_ast_response"
  }
}

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Unauthorized

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Code Example

                  ## default
# 

# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

# Curl command
curl -X POST "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-ast" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "Authorization: Bearer ${DD_BEARER_TOKEN}" \ -d @- << EOF { "data": { "attributes": { "code": "aW1wb3J0IHN5cw==", "file_encoding": "utf-8", "language": "python" }, "type": "get_ast_request" } } EOF
"""
Get AST for source code returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.security_monitoring_api import SecurityMonitoringApi
from datadog_api_client.v2.model.get_ast_request import GetAstRequest
from datadog_api_client.v2.model.get_ast_request_data import GetAstRequestData
from datadog_api_client.v2.model.get_ast_request_data_attributes import GetAstRequestDataAttributes
from datadog_api_client.v2.model.get_ast_request_data_type import GetAstRequestDataType

body = GetAstRequest(
    data=GetAstRequestData(
        attributes=GetAstRequestDataAttributes(
            code="aW1wb3J0IHN5cw==",
            file_encoding="utf-8",
            language="python",
        ),
        type=GetAstRequestDataType.GET_AST_REQUEST,
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
configuration.unstable_operations["create_static_analysis_ast"] = True
with ApiClient(configuration) as api_client:
    api_instance = SecurityMonitoringApi(api_client)
    response = api_instance.create_static_analysis_ast(body=body)

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
# Get AST for source code returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
  config.unstable_operations["v2.create_static_analysis_ast".to_sym] = true
end
api_instance = DatadogAPIClient::V2::SecurityMonitoringAPI.new

body = DatadogAPIClient::V2::GetAstRequest.new({
  data: DatadogAPIClient::V2::GetAstRequestData.new({
    attributes: DatadogAPIClient::V2::GetAstRequestDataAttributes.new({
      code: "aW1wb3J0IHN5cw==",
      file_encoding: "utf-8",
      language: "python",
    }),
    type: DatadogAPIClient::V2::GetAstRequestDataType::GET_AST_REQUEST,
  }),
})
p api_instance.create_static_analysis_ast(body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
// Get AST for source code returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.GetAstRequest{
		Data: datadogV2.GetAstRequestData{
			Attributes: datadogV2.GetAstRequestDataAttributes{
				Code:         "aW1wb3J0IHN5cw==",
				FileEncoding: "utf-8",
				Language:     "python",
			},
			Type: datadogV2.GETASTREQUESTDATATYPE_GET_AST_REQUEST,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateStaticAnalysisAst", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSecurityMonitoringApi(apiClient)
	resp, r, err := api.CreateStaticAnalysisAst(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SecurityMonitoringApi.CreateStaticAnalysisAst`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `SecurityMonitoringApi.CreateStaticAnalysisAst`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
// Get AST for source code returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SecurityMonitoringApi;
import com.datadog.api.client.v2.model.GetAstRequest;
import com.datadog.api.client.v2.model.GetAstRequestData;
import com.datadog.api.client.v2.model.GetAstRequestDataAttributes;
import com.datadog.api.client.v2.model.GetAstRequestDataType;
import com.datadog.api.client.v2.model.GetAstResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    defaultClient.setUnstableOperationEnabled("v2.createStaticAnalysisAst", true);
    SecurityMonitoringApi apiInstance = new SecurityMonitoringApi(defaultClient);

    GetAstRequest body =
        new GetAstRequest()
            .data(
                new GetAstRequestData()
                    .attributes(
                        new GetAstRequestDataAttributes()
                            .code("aW1wb3J0IHN5cw==")
                            .fileEncoding("utf-8")
                            .language("python"))
                    .type(GetAstRequestDataType.GET_AST_REQUEST));

    try {
      GetAstResponse result = apiInstance.createStaticAnalysisAst(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SecurityMonitoringApi#createStaticAnalysisAst");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
// Get AST for source code returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_security_monitoring::SecurityMonitoringAPI;
use datadog_api_client::datadogV2::model::GetAstRequest;
use datadog_api_client::datadogV2::model::GetAstRequestData;
use datadog_api_client::datadogV2::model::GetAstRequestDataAttributes;
use datadog_api_client::datadogV2::model::GetAstRequestDataType;

#[tokio::main]
async fn main() {
    let body = GetAstRequest::new(GetAstRequestData::new(
        GetAstRequestDataAttributes::new(
            "aW1wb3J0IHN5cw==".to_string(),
            "utf-8".to_string(),
            "python".to_string(),
        ),
        GetAstRequestDataType::GET_AST_REQUEST,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.create_static_analysis_ast", true);
    let api = SecurityMonitoringAPI::with_config(configuration);
    let resp = api.create_static_analysis_ast(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
/**
 * Get AST for source code returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
configuration.unstableOperations["v2.createStaticAnalysisAst"] = true;
const apiInstance = new v2.SecurityMonitoringApi(configuration);

const params: v2.SecurityMonitoringApiCreateStaticAnalysisAstRequest = {
  body: {
    data: {
      attributes: {
        code: "aW1wb3J0IHN5cw==",
        fileEncoding: "utf-8",
        language: "python",
      },
      type: "get_ast_request",
    },
  },
};

apiInstance
  .createStaticAnalysisAst(params)
  .then((data: v2.GetAstResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" tsc "example.ts"